Index: /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/OPA_SRC/LBC/lib_mpp.F90
===================================================================
--- /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/OPA_SRC/LBC/lib_mpp.F90	(revision 3569)
+++ /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/OPA_SRC/LBC/lib_mpp.F90	(revision 3570)
@@ -80,10 +80,6 @@
    END INTERFACE
    INTERFACE mpp_sum
-# if defined key_mpp_rep
       MODULE PROCEDURE mppsum_a_int, mppsum_int, mppsum_a_real, mppsum_real, &
                        mppsum_realdd, mppsum_a_realdd
-# else
-      MODULE PROCEDURE mppsum_a_int, mppsum_int, mppsum_a_real, mppsum_real
-# endif
    END INTERFACE
    INTERFACE mpp_lbc_north
@@ -114,10 +110,9 @@
 !$AGRIF_END_DO_NOT_TREAT
 
-# if defined key_mpp_rep
    INTEGER :: MPI_SUMDD
-# endif
 
    ! variables used in case of sea-ice
-   INTEGER, PUBLIC ::   ncomm_ice       !: communicator made by the processors with sea-ice
+   INTEGER, PUBLIC ::   ncomm_ice       !: communicator made by the processors with sea-ice (public so that it can be freed in limthd)
+   INTEGER ::   ngrp_iworld     !  group ID for the world processors (for rheology)
    INTEGER ::   ngrp_ice        !  group ID for the ice processors (for rheology)
    INTEGER ::   ndim_rank_ice   !  number of 'ice' processors
@@ -355,7 +350,5 @@
       mynode = mpprank
       ! 
-#if defined key_mpp_rep
       CALL MPI_OP_CREATE(DDPDD_MPI, .TRUE., MPI_SUMDD, ierr)
-#endif
       !
    END FUNCTION mynode
@@ -1506,5 +1499,4 @@
    END SUBROUTINE mppsum_real
 
-# if defined key_mpp_rep
    SUBROUTINE mppsum_realdd( ytab, kcom )
       !!----------------------------------------------------------------------
@@ -1559,5 +1551,4 @@
 
    END SUBROUTINE mppsum_a_realdd
-# endif   
    
    SUBROUTINE mpp_minloc2d( ptab, pmask, pmin, ki,kj )
@@ -1977,5 +1968,5 @@
       !!      ndim_rank_ice = number of processors with ice
       !!      nrank_ice (ndim_rank_ice) = ice processors
-      !!      ngrp_world = group ID for the world processors
+      !!      ngrp_iworld = group ID for the world processors
       !!      ngrp_ice = group ID for the ice processors
       !!      ncomm_ice = communicator for the ice procs.
@@ -2026,8 +2017,8 @@
 
       ! Create the world group
-      CALL MPI_COMM_GROUP( mpi_comm_opa, ngrp_world, ierr )
+      CALL MPI_COMM_GROUP( mpi_comm_opa, ngrp_iworld, ierr )
 
       ! Create the ice group from the world group
-      CALL MPI_GROUP_INCL( ngrp_world, ndim_rank_ice, nrank_ice, ngrp_ice, ierr )
+      CALL MPI_GROUP_INCL( ngrp_iworld, ndim_rank_ice, nrank_ice, ngrp_ice, ierr )
 
       ! Create the ice communicator , ie the pool of procs with sea-ice
@@ -2036,6 +2027,9 @@
       ! Find proc number in the world of proc 0 in the north
       ! The following line seems to be useless, we just comment & keep it as reminder
-      ! CALL MPI_GROUP_TRANSLATE_RANKS(ngrp_ice,1,0,ngrp_world,n_ice_root,ierr)
-      !
+      ! CALL MPI_GROUP_TRANSLATE_RANKS(ngrp_ice,1,0,ngrp_iworld,n_ice_root,ierr)
+      !
+      CALL MPI_GROUP_FREE(ngrp_ice, ierr)
+      CALL MPI_GROUP_FREE(ngrp_iworld, ierr)
+
       DEALLOCATE(kice, zwork)
       !
@@ -2599,5 +2593,4 @@
    END SUBROUTINE mpi_init_opa
 
-#if defined key_mpp_rep
    SUBROUTINE DDPDD_MPI (ydda, yddb, ilen, itype)
       !!---------------------------------------------------------------------
@@ -2628,5 +2621,4 @@
 
    END SUBROUTINE DDPDD_MPI
-#endif
 
 #else
Index: /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/OPA_SRC/SBC/sbcmod.F90
===================================================================
--- /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/OPA_SRC/SBC/sbcmod.F90	(revision 3569)
+++ /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/OPA_SRC/SBC/sbcmod.F90	(revision 3570)
@@ -272,23 +272,20 @@
       !                                            !==  Misc. Options  ==!
       
-      SELECT CASE( nn_ice )                                     ! Update heat and freshwater fluxes over sea-ice areas
-      CASE(  1 )   ;       CALL sbc_ice_if   ( kt )                  ! Ice-cover climatology ("Ice-if" model)
-         !                                                      
-      CASE(  2 )   ;       CALL sbc_ice_lim_2( kt, nsbc )            ! LIM-2 ice model
-         IF( lk_bdy )      CALL bdy_ice_lim_2( kt )                  ! BDY boundary condition
-         !                                                     
-      CASE(  3 )   ;       CALL sbc_ice_lim  ( kt, nsbc )            ! LIM-3 ice model
-         !
-      CASE(  4 )   ;       CALL sbc_ice_cice ( kt, nsbc )            ! CICE ice model
+      SELECT CASE( nn_ice )                                       ! Update heat and freshwater fluxes over sea-ice areas
+      CASE(  1 )   ;         CALL sbc_ice_if   ( kt )                ! Ice-cover climatology ("Ice-if" model)
+      CASE(  2 )   ;         CALL sbc_ice_lim_2( kt, nsbc )          ! LIM-2 ice model
+              IF( lk_bdy )   CALL bdy_ice_lim_2( kt )                ! BDY boundary condition
+      CASE(  3 )   ;         CALL sbc_ice_lim  ( kt, nsbc )          ! LIM-3 ice model
+      CASE(  4 )   ;         CALL sbc_ice_cice ( kt, nsbc )          ! CICE ice model
       END SELECT                                              
 
-      IF( ln_rnf       )   CALL sbc_rnf( kt )                   ! add runoffs to fresh water fluxes
+      IF( ln_rnf         )   CALL sbc_rnf( kt )                   ! add runoffs to fresh water fluxes
  
-      IF( ln_ssr       )   CALL sbc_ssr( kt )                   ! add SST/SSS damping term
-
-      IF( nn_fwb  /= 0 )   CALL sbc_fwb( kt, nn_fwb, nn_fsbc )  ! control the freshwater budget
-
-      IF( nclosea == 1 )   CALL sbc_clo( kt )                   ! treatment of closed sea in the model domain 
-      !                                                         ! (update freshwater fluxes)
+      IF( ln_ssr         )   CALL sbc_ssr( kt )                   ! add SST/SSS damping term
+
+      IF( nn_fwb    /= 0 )   CALL sbc_fwb( kt, nn_fwb, nn_fsbc )  ! control the freshwater budget
+
+      IF( nn_closea == 1 )   CALL sbc_clo( kt )                   ! treatment of closed sea in the model domain 
+      !                                                           ! (update freshwater fluxes)
 !RBbug do not understand why see ticket 667
       CALL lbc_lnk( emp, 'T', 1. )
Index: /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/OPA_SRC/SBC/sbcrnf.F90
===================================================================
--- /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/OPA_SRC/SBC/sbcrnf.F90	(revision 3569)
+++ /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/OPA_SRC/SBC/sbcrnf.F90	(revision 3570)
@@ -457,7 +457,7 @@
       CALL iom_close( inum )                                      ! close file
       
-      IF( nclosea == 1 )    CALL clo_rnf( rnfmsk )                ! closed sea inflow set as ruver mouth
-
-      rnfmsk_z(:)   = 0._wp                                        ! vertical structure 
+      IF( nn_closea == 1 )   CALL clo_rnf( rnfmsk )               ! closed sea inflow set as ruver mouth
+
+      rnfmsk_z(:)   = 0._wp                                       ! vertical structure 
       rnfmsk_z(1)   = 1.0
       rnfmsk_z(2)   = 1.0                                         ! **********
Index: /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/OPA_SRC/TRA/traldf_iso_grif.F90
===================================================================
--- /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/OPA_SRC/TRA/traldf_iso_grif.F90	(revision 3569)
+++ /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/OPA_SRC/TRA/traldf_iso_grif.F90	(revision 3570)
@@ -225,6 +225,6 @@
             DO jj = 2, jpjm1
                DO ji = fs_2, fs_jpim1  ! vector opt.
-                  zw3d(ji,jj,jk) = (psiy_eiv(ji,jj,jk) - psiy_eiv(ji,jj-1,jk))/e2v(ji,jj) + &
-                       &    (psix_eiv(ji,jj,jk) - psix_eiv(ji-1,jj,jk))/e1u(ji,jj) ! w_eiv = dpsiy/dy + dpsiy/dx
+                  zw3d(ji,jj,jk) = (psiy_eiv(ji,jj,jk) - psiy_eiv(ji,jj-1,jk))/e2t(ji,jj) + &
+                       &    (psix_eiv(ji,jj,jk) - psix_eiv(ji-1,jj,jk))/e1t(ji,jj) ! w_eiv = dpsiy/dy + dpsiy/dx
                END DO
             END DO
Index: /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/OPA_SRC/TRD/trdtra.F90
===================================================================
--- /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/OPA_SRC/TRD/trdtra.F90	(revision 3569)
+++ /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/OPA_SRC/TRD/trdtra.F90	(revision 3570)
@@ -8,5 +8,5 @@
    !!            3.3  !  2010-06  (C. Ethe) merge TRA-TRC 
    !!----------------------------------------------------------------------
-#if  defined key_trdtra || defined key_trdmld || defined key_trdmld_trc 
+#if  defined key_trdtra || defined key_trdtrc || defined key_trdmld || defined key_trdmld_trc 
    !!----------------------------------------------------------------------
    !!   trd_tra      : Call the trend to be computed
Index: /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfddm.F90
===================================================================
--- /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfddm.F90	(revision 3569)
+++ /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfddm.F90	(revision 3570)
@@ -227,6 +227,8 @@
       ENDIF
       !
-      !                              ! allocate zdfddm arrays
+      !                               ! allocate zdfddm arrays
       IF( zdf_ddm_alloc() /= 0 )   CALL ctl_stop( 'STOP', 'zdf_ddm_init : unable to allocate arrays' )
+      !                               ! initialization to masked Kz
+      avs(:,:,:) = rn_avt0 * tmask(:,:,:) 
       !
    END SUBROUTINE zdf_ddm_init
Index: /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/OPA_SRC/ZDF/zdftke.F90
===================================================================
--- /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/OPA_SRC/ZDF/zdftke.F90	(revision 3569)
+++ /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/OPA_SRC/ZDF/zdftke.F90	(revision 3570)
@@ -87,4 +87,6 @@
    REAL(wp)        , ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   htau           ! depth of tke penetration (nn_htau)
    REAL(wp)        , ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   dissl          ! now mixing lenght of dissipation
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   avt_k , avm_k  ! not enhanced Kz
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   avmu_k, avmv_k ! not enhanced Kz
 #if defined key_c1d
    !                                                                        !!** 1D cfg only  **   ('key_c1d')
@@ -112,5 +114,7 @@
          &      e_pdl(jpi,jpj,jpk) , e_ric(jpi,jpj,jpk) ,                          &
 #endif
-         &      en   (jpi,jpj,jpk) , htau (jpi,jpj)     , dissl(jpi,jpj,jpk) , STAT= zdf_tke_alloc )
+         &      en    (jpi,jpj,jpk) , htau  (jpi,jpj)    , dissl(jpi,jpj,jpk) ,     & 
+         &      avt_k (jpi,jpj,jpk) , avm_k (jpi,jpj,jpk),                          &
+         &      avmu_k(jpi,jpj,jpk) , avmv_k(jpi,jpj,jpk), STAT= zdf_tke_alloc      )
          !
       IF( lk_mpp             )   CALL mpp_sum ( zdf_tke_alloc )
@@ -168,7 +172,19 @@
       !!----------------------------------------------------------------------
       !
+      IF( kt /= nit000 ) THEN   ! restore before value to compute tke
+         avt (:,:,:) = avt_k (:,:,:) 
+         avm (:,:,:) = avm_k (:,:,:) 
+         avmu(:,:,:) = avmu_k(:,:,:) 
+         avmv(:,:,:) = avmv_k(:,:,:) 
+      ENDIF 
+      !
       CALL tke_tke      ! now tke (en)
       !
       CALL tke_avn      ! now avt, avm, avmu, avmv
+      !
+      avt_k (:,:,:) = avt (:,:,:) 
+      avm_k (:,:,:) = avm (:,:,:) 
+      avmu_k(:,:,:) = avmu(:,:,:) 
+      avmv_k(:,:,:) = avmv(:,:,:) 
       !
    END SUBROUTINE zdf_tke
@@ -811,10 +827,10 @@
         !                                   ! -------------------
         IF(lwp) WRITE(numout,*) '---- tke-rst ----'
-        CALL iom_rstput( kt, nitrst, numrow, 'en'   , en    )
-        CALL iom_rstput( kt, nitrst, numrow, 'avt'  , avt   )
-        CALL iom_rstput( kt, nitrst, numrow, 'avm'  , avm   )
-        CALL iom_rstput( kt, nitrst, numrow, 'avmu' , avmu  )
-        CALL iom_rstput( kt, nitrst, numrow, 'avmv' , avmv  )
-        CALL iom_rstput( kt, nitrst, numrow, 'dissl', dissl )
+        CALL iom_rstput( kt, nitrst, numrow, 'en'   , en     )
+        CALL iom_rstput( kt, nitrst, numrow, 'avt'  , avt_k  )
+        CALL iom_rstput( kt, nitrst, numrow, 'avm'  , avm_k  )
+        CALL iom_rstput( kt, nitrst, numrow, 'avmu' , avmu_k )
+        CALL iom_rstput( kt, nitrst, numrow, 'avmv' , avmv_k )
+        CALL iom_rstput( kt, nitrst, numrow, 'dissl', dissl  )
         !
      ENDIF
Index: /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/OPA_SRC/lib_fortran.F90
===================================================================
--- /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/OPA_SRC/lib_fortran.F90	(revision 3569)
+++ /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/OPA_SRC/lib_fortran.F90	(revision 3570)
@@ -14,13 +14,14 @@
    !!                 of intrinsinc sign function
    !!----------------------------------------------------------------------
-   USE par_oce          ! Ocean parameter
-   USE lib_mpp          ! distributed memory computing
-   USE dom_oce          ! ocean domain
-   USE in_out_manager   ! I/O manager
+   USE par_oce         ! Ocean parameter
+   USE dom_oce         ! ocean domain
+   USE in_out_manager  ! I/O manager
+   USE lib_mpp         ! distributed memory computing
 
    IMPLICIT NONE
    PRIVATE
 
-   PUBLIC glob_sum
+   PUBLIC   glob_sum   ! used in many places
+   PUBLIC   DDPDD      ! also used in closea module
 #if defined key_nosignedzero
    PUBLIC SIGN
@@ -47,4 +48,5 @@
 
 #if ! defined key_mpp_rep
+
    FUNCTION glob_sum_2d( ptab ) 
       !!-----------------------------------------------------------------------
@@ -246,4 +248,5 @@
    END FUNCTION glob_sum_3d_a   
 
+#endif
 
    SUBROUTINE DDPDD( ydda, yddb )
@@ -280,5 +283,4 @@
       !
    END SUBROUTINE DDPDD
-#endif
 
 #if defined key_nosignedzero
Index: /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/OPA_SRC/nemogcm.F90
===================================================================
--- /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/OPA_SRC/nemogcm.F90	(revision 3569)
+++ /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/OPA_SRC/nemogcm.F90	(revision 3570)
@@ -413,4 +413,5 @@
          WRITE(numout,*) '      number of proc. following j     nn_jsplt   = ', nn_jsplt
          WRITE(numout,*) '      benchmark parameter (0/1)       nn_bench   = ', nn_bench
+         WRITE(numout,*) '      timing activated    (0/1)       nn_timing  = ', nn_timing
       ENDIF
       !
Index: /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/OPA_SRC/timing.F90
===================================================================
--- /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/OPA_SRC/timing.F90	(revision 3569)
+++ /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/OPA_SRC/timing.F90	(revision 3570)
@@ -76,5 +76,4 @@
    LOGICAL :: ln_onefile = .TRUE. 
    LOGICAL :: lwriter
-
    !!----------------------------------------------------------------------
    !! NEMO/OPA 4.0 , NEMO Consortium (2011)
@@ -322,6 +321,6 @@
       IF( lwriter ) WRITE(numtime,*) 'Total timing (sum) :'
       IF( lwriter ) WRITE(numtime,*) '--------------------'
-      IF( lwriter ) WRITE(numtime,*) 'Elapsed Time (s)  ','CPU Time (s)'
-      IF( lwriter ) WRITE(numtime,'(5x,f12.3,2x,f12.3)')  tot_etime, tot_ctime
+      IF( lwriter ) WRITE(numtime,"('Elapsed Time (s)  CPU Time (s)')")
+      IF( lwriter ) WRITE(numtime,'(5x,f12.3,1x,f12.3)')  tot_etime, tot_ctime
       IF( lwriter ) WRITE(numtime,*) 
 #if defined key_mpp_mpi
@@ -406,13 +405,23 @@
       TYPE(timer), POINTER :: sl_timer_ave      => NULL()
       INTEGER :: icode
+      INTEGER :: ierr
       LOGICAL :: ll_ord           
       CHARACTER(len=200) :: clfmt              
                  
       ! Initialised the global strucutre   
-      ALLOCATE(sl_timer_glob_root)
-      ALLOCATE(sl_timer_glob_root%cname     (jpnij))
-      ALLOCATE(sl_timer_glob_root%tsum_cpu  (jpnij))
-      ALLOCATE(sl_timer_glob_root%tsum_clock(jpnij))
-      ALLOCATE(sl_timer_glob_root%niter     (jpnij))
+      ALLOCATE(sl_timer_glob_root, Stat=ierr)
+      IF(ierr /= 0)THEN
+         WRITE(numtime,*) 'Failed to allocate global timing structure in waver_info'
+         RETURN
+      END IF
+
+      ALLOCATE(sl_timer_glob_root%cname     (jpnij), &
+               sl_timer_glob_root%tsum_cpu  (jpnij), &
+               sl_timer_glob_root%tsum_clock(jpnij), &
+               sl_timer_glob_root%niter     (jpnij), Stat=ierr)
+      IF(ierr /= 0)THEN
+         WRITE(numtime,*) 'Failed to allocate global timing structure in waver_info'
+         RETURN
+      END IF
       sl_timer_glob_root%cname(:)       = ''
       sl_timer_glob_root%tsum_cpu(:)   = 0._wp
@@ -421,9 +430,11 @@
       sl_timer_glob_root%next => NULL()
       sl_timer_glob_root%prev => NULL()
-      ALLOCATE(sl_timer_glob)
-      ALLOCATE(sl_timer_glob%cname     (jpnij))
-      ALLOCATE(sl_timer_glob%tsum_cpu  (jpnij))
-      ALLOCATE(sl_timer_glob%tsum_clock(jpnij))
-      ALLOCATE(sl_timer_glob%niter     (jpnij))
+      !ARPDBG - don't need to allocate a pointer that's immediately then
+      !         set to point to some other object.
+      !ALLOCATE(sl_timer_glob)
+      !ALLOCATE(sl_timer_glob%cname     (jpnij))
+      !ALLOCATE(sl_timer_glob%tsum_cpu  (jpnij))
+      !ALLOCATE(sl_timer_glob%tsum_clock(jpnij))
+      !ALLOCATE(sl_timer_glob%niter     (jpnij))
       sl_timer_glob => sl_timer_glob_root
       !
@@ -451,5 +462,5 @@
          sl_timer_ave => sl_timer_ave_root            
       ENDIF 
-      
+
       ! Gather info from all processors
       s_timer => s_timer_root
@@ -467,4 +478,5 @@
                          sl_timer_glob%niter, 1, MPI_INTEGER,   &
                          0, MPI_COMM_OPA, icode)
+
          IF( narea == 1 .AND. ASSOCIATED(s_timer%next) ) THEN
             ALLOCATE(sl_timer_glob%next)
@@ -479,4 +491,6 @@
          s_timer => s_timer%next
       END DO      
+
+         WRITE(*,*) 'ARPDBG: timing: done gathers'
       
       IF( narea == 1 ) THEN    
@@ -500,7 +514,9 @@
             ENDIF
             sl_timer_glob => sl_timer_glob%next                                
-         END DO         
+         END DO
+
+         WRITE(*,*) 'ARPDBG: timing: done computing stats'
       
-         ! reorder the avearged list by CPU time      
+         ! reorder the averaged list by CPU time      
          s_wrk => NULL()
          sl_timer_ave => sl_timer_ave_root
@@ -509,30 +525,34 @@
             sl_timer_ave => sl_timer_ave_root
             DO WHILE( ASSOCIATED( sl_timer_ave%next ) )
-            IF( .NOT. ASSOCIATED(sl_timer_ave%next) ) EXIT
+
+               IF( .NOT. ASSOCIATED(sl_timer_ave%next) ) EXIT
+
                IF ( sl_timer_ave%tsum_clock < sl_timer_ave%next%tsum_clock ) THEN 
                   ALLOCATE(s_wrk)
+                  ! Copy data into the new object pointed to by s_wrk
                   s_wrk = sl_timer_ave%next
+                  ! Insert this new timer object before our current position
                   CALL insert  (sl_timer_ave, sl_timer_ave_root, s_wrk)
+                  ! Remove the old object from the list
                   CALL suppress(sl_timer_ave%next)            
                   ll_ord = .FALSE.
                   CYCLE            
                ENDIF           
-            IF( ASSOCIATED(sl_timer_ave%next) ) sl_timer_ave => sl_timer_ave%next
+               IF( ASSOCIATED(sl_timer_ave%next) ) sl_timer_ave => sl_timer_ave%next
             END DO         
-           IF( ll_ord ) EXIT
+            IF( ll_ord ) EXIT
          END DO
 
          ! write averaged info
-         WRITE(numtime,*) 'Averaged timing on all processors :'
-         WRITE(numtime,*) '-----------------------------------'
-         WRITE(numtime,*) 'Section             ',                &
-         &   'Elapsed Time (s)  ','Elapsed Time (%)  ',          &
-         &   'CPU Time(s)  ','CPU Time (%)  ','CPU/Elapsed  ',   &
-         &   'Max Elapsed (%)  ','Min elapsed (%)  ',            &           
-         &   'Frequency' 
+         WRITE(numtime,"('Averaged timing on all processors :')")
+         WRITE(numtime,"('-----------------------------------')")
+         WRITE(numtime,"('Section',13x,'Elap. Time(s)',2x,'Elap. Time(%)',2x, &
+         &   'CPU Time(s)',2x,'CPU Time(%)',2x,'CPU/Elap',1x,   &
+         &   'Max elap(%)',2x,'Min elap(%)',2x,            &           
+         &   'Freq')")
          sl_timer_ave => sl_timer_ave_root  
-         clfmt = '(1x,a,4x,f12.3,6x,f12.3,x,f12.3,2x,f12.3,6x,f7.3,5x,f12.3,5x,f12.3,2x,f9.2)'
+         clfmt = '((A),E15.7,2x,f6.2,5x,f12.2,5x,f6.2,5x,f7.2,2x,f12.2,4x,f6.2,2x,f9.2)'
          DO WHILE ( ASSOCIATED(sl_timer_ave) )
-            WRITE(numtime,TRIM(clfmt))   sl_timer_ave%cname,                            &
+            WRITE(numtime,TRIM(clfmt))   sl_timer_ave%cname(1:18),                            &
             &   sl_timer_ave%tsum_clock,sl_timer_ave%tsum_clock*100.*jpnij/tot_etime,   &
             &   sl_timer_ave%tsum_cpu  ,sl_timer_ave%tsum_cpu*100.*jpnij/tot_ctime  ,   &
@@ -712,9 +732,9 @@
       !!----------------------------------------------------------------------
       l_initdone = .TRUE. 
-      IF(lwp) WRITE(numout,*)
-      IF(lwp) WRITE(numout,*) 'timing_reset : instrumented routines for timing'
-      IF(lwp) WRITE(numout,*) '~~~~~~~~~~~~'
-      CALL timing_list(s_timer_root)
-      WRITE(numout,*)
+!      IF(lwp) WRITE(numout,*)
+!      IF(lwp) WRITE(numout,*) 'timing_reset : instrumented routines for timing'
+!      IF(lwp) WRITE(numout,*) '~~~~~~~~~~~~'
+!      CALL timing_list(s_timer_root)
+!      WRITE(numout,*)
       !
    END SUBROUTINE timing_reset
@@ -734,5 +754,5 @@
       !!----------------------------------------------------------------------
       !!               ***  ROUTINE insert  ***
-      !! ** Purpose :   insert an element in  imer structure
+      !! ** Purpose :   insert an element in timer structure
       !!----------------------------------------------------------------------
       TYPE(timer), POINTER, INTENT(inout) :: sd_current, sd_root, sd_ptr
@@ -740,4 +760,6 @@
      
       IF( ASSOCIATED( sd_current, sd_root ) ) THEN
+         ! If our current element is the root element then
+         ! replace it with the one being inserted
          sd_root => sd_ptr
       ELSE
@@ -747,4 +769,8 @@
       sd_ptr%prev     => sd_current%prev
       sd_current%prev => sd_ptr
+      ! Nullify the pointer to the new element now that it is held
+      ! within the list. If we don't do this then a subsequent call
+      ! to ALLOCATE memory to this pointer will fail.
+      sd_ptr => NULL()
       !    
    END SUBROUTINE insert
@@ -764,4 +790,5 @@
       IF ( ASSOCIATED(sl_temp%next) ) sl_temp%next%prev => sl_temp%prev
       DEALLOCATE(sl_temp)
+      sl_temp => NULL()
       !
     END SUBROUTINE suppress
Index: /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zsink.F90
===================================================================
--- /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zsink.F90	(revision 3569)
+++ /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zsink.F90	(revision 3570)
@@ -295,5 +295,5 @@
       ENDIF
       !
-      CALL wrk_alloc( jpi, jpj, jpk, znum3d )
+      CALL wrk_dealloc( jpi, jpj, jpk, znum3d )
       !
       IF( nn_timing == 1 )  CALL timing_stop('p4z_sink')
Index: /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/TOP_SRC/TRP/trczdf.F90
===================================================================
--- /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/TOP_SRC/TRP/trczdf.F90	(revision 3569)
+++ /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/TOP_SRC/TRP/trczdf.F90	(revision 3570)
@@ -101,5 +101,5 @@
       END SELECT
 
-      IF( l_trdtra )   THEN                      ! save the vertical diffusive trends for further diagnostics
+      IF( l_trdtrc )   THEN                      ! save the vertical diffusive trends for further diagnostics
          DO jn = 1, jptra
             DO jk = 1, jpkm1
Index: /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/TOP_SRC/TRP/trdmod_trc.F90
===================================================================
--- /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/TOP_SRC/TRP/trdmod_trc.F90	(revision 3569)
+++ /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/TOP_SRC/TRP/trdmod_trc.F90	(revision 3570)
@@ -59,4 +59,5 @@
       ! Mixed layer trends for passive tracers
       !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
+#if defined key_trdmld_trc  
       IF( lk_trdmld_trc .AND. ln_trdtrc( kjn ) ) THEN
          !
@@ -82,17 +83,23 @@
          !
       END IF
+#endif
 
       IF( lk_trdtrc .AND. ln_trdtrc( kjn ) ) THEN
          !
          SELECT CASE( ktrd )
-         CASE( jptra_trd_xad )       ;    WRITE (cltra,'("XAD_",16a)')   ctrcnm(kjn)
-         CASE( jptra_trd_yad )       ;    WRITE (cltra,'("YAD_",16a)')   ctrcnm(kjn)
-         CASE( jptra_trd_zad )       ;    WRITE (cltra,'("ZAD_",16a)')   ctrcnm(kjn)
-         CASE( jptra_trd_ldf )       ;    WRITE (cltra,'("LDF_",16a)')   ctrcnm(kjn)
-         CASE( jptra_trd_bbl )       ;    WRITE (cltra,'("BBL_",16a)')   ctrcnm(kjn)
-         CASE( jptra_trd_zdf )       ;    WRITE (cltra,'("ZDF_",16a)')   ctrcnm(kjn)
-         CASE( jptra_trd_dmp )       ;    WRITE (cltra,'("DMP_",16a)')   ctrcnm(kjn)
-         CASE( jptra_trd_nsr )       ;    WRITE (cltra,'("FOR_",16a)')   ctrcnm(kjn)
+         CASE( jptra_trd_xad  )       ;    WRITE (cltra,'("XAD_",4a)')
+         CASE( jptra_trd_yad  )       ;    WRITE (cltra,'("YAD_",4a)')
+         CASE( jptra_trd_zad  )       ;    WRITE (cltra,'("ZAD_",4a)')
+         CASE( jptra_trd_ldf  )       ;    WRITE (cltra,'("LDF_",4a)')
+         CASE( jptra_trd_bbl  )       ;    WRITE (cltra,'("BBL_",4a)')
+         CASE( jptra_trd_nsr  )       ;    WRITE (cltra,'("FOR_",4a)')
+         CASE( jptra_trd_zdf  )       ;    WRITE (cltra,'("ZDF_",4a)')
+         CASE( jptra_trd_dmp  )       ;    WRITE (cltra,'("DMP_",4a)')
+         CASE( jptra_trd_sms  )       ;    WRITE (cltra,'("SMS_",4a)')
+         CASE( jptra_trd_atf  )       ;    WRITE (cltra,'("ATF_",4a)')
+         CASE( jptra_trd_radb )       ;    WRITE (cltra,'("RDB_",4a)')
+         CASE( jptra_trd_radn )       ;    WRITE (cltra,'("RDN_",4a)')
          END SELECT
+                                          cltra = TRIM(cltra)//TRIM(ctrcnm(kjn))
                                           CALL iom_put( cltra,  ptrtrd(:,:,:) )
          !
@@ -111,5 +118,7 @@
       !!----------------------------------------------------------------------
 
+#if defined key_trdmld_trc  
       CALL trd_mld_bio_zint( ptrbio, ktrd ) ! Verticaly integrated biological trends
+#endif
 
    END SUBROUTINE trd_mod_trc_bio
Index: /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-PW6_VARGAS
===================================================================
--- /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-PW6_VARGAS	(revision 3569)
+++ /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-PW6_VARGAS	(revision 3570)
@@ -11,5 +11,5 @@
 # @ total_tasks = NPROCS
 # time
-# @ wall_clock_limit = 0:30:00
+# @ wall_clock_limit = 1:30:00
 # @ queue
 
Index: /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-X64_TITANE
===================================================================
--- /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-X64_TITANE	(revision 3569)
+++ /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-X64_TITANE	(revision 3570)
@@ -54,9 +54,9 @@
 #  Run the parallel MPI executable 
 #
+  if [ MPI_FLAG == "yes" ]; then
   echo "Running time ${MPIRUN} ./opa"
-#
-  if [ MPI_FLAG == "yes" ]; then
      time ${MPIRUN} ./opa
   else
+  echo "Running time ./opa"
      time ./opa
   fi
Index: /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-ifort_MERCATOR_CLUSTER
===================================================================
--- /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-ifort_MERCATOR_CLUSTER	(revision 3569)
+++ /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-ifort_MERCATOR_CLUSTER	(revision 3570)
@@ -57,10 +57,10 @@
 #  Run the parallel MPI executable 
 #
+  if [ MPI_FLAG == "yes" ]; then
   echo "Running time ${MPIRUN} ./opa"
-#
-  if [ MPI_FLAG == "yes" ]; then
      time ${MPIRUN} ./opa
 #cbr     mpirun -np $OCEANCORES ./opa
   else
+  echo "Running time ./opa"
      time ./opa
   fi
Index: /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/SETTE/BATCH_TEMPLATE/sette_batch_template
===================================================================
--- /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/SETTE/BATCH_TEMPLATE/sette_batch_template	(revision 3569)
+++ /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/SETTE/BATCH_TEMPLATE/sette_batch_template	(revision 3570)
@@ -64,10 +64,9 @@
 #  Run the parallel MPI executable 
 #
+  if [ MPI_FLAG == "yes" ]; then
   echo "Running time ${MPIRUN} ./opa"
-#
-
-  if [ MPI_FLAG == "yes" ]; then
      time ${MPIRUN} ./opa
   else
+  echo "Running time./opa"
      time ./opa
   fi
